var isChrome = browser === undefined;
var onionDomain = "kiwifarmsaaf4t2h7gc3dfc5ojhmqruw2nit3uejrpiagrxeuxiyxcyd.onion"

function createBlockingRequest(url, domain) {
    // Chrome doesn't seem to care about sameSite for the anti-DDoS PoW cookie
    // Thank goodness as I would have to rewrite a bunch of it to work with Chrome anyway
    if (domain === onionDomain && !isChrome) {
        browser.cookies.getAll({
            url: `https://${onionDomain}`,
            name: "z_ddos_pow", firstPartyDomain: onionDomain
        }).then(
            (cookie) => {
                // Track whether we're just cleaning up a stale PoW that has doubled up
                let cookieCleanup = false;
                if (cookie === null) return;
                // Doubled up on cookies, gotta delete one. FF defaults to the oldest thankfully
                if (cookie.length > 1) cookieCleanup = true;
                // Nothing needs to be done
                if (cookie.length === 1 && cookie[0].sameSite !== "strict") return;
                console.log("Recreating .onion DDoS PoW cookie with sameSite no_restriction", cookieCleanup)
                let pow_val = cookie[0].value;
                // Delete the cookie and recreate it with a more relaxed sameSite attribute
                browser.cookies.remove({
                    url: `https:/${onionDomain}`,
                    name: "z_ddos_pow",
                    firstPartyDomain: onionDomain
                }).then(() => {
                    if (cookieCleanup) return;
                    browser.cookies.set({
                        url: `https://${onionDomain}`,
                        name: "z_ddos_pow",
                        firstPartyDomain: onionDomain,
                        value: pow_val,
                        sameSite: "no_restriction",
                        domain: `.${onionDomain}` // Needs the . so it gets sent to uploads, no-cookie, etc.
                    })
                })
            })
    }
    if (url.host.includes(domain)) return;
    // Try to preserve uploads, no-cookie, etc. subdomain
    let parts = url.host.split('.');
    // Man, what a lousy hack
    if (parts[0] === "no-cookie" || parts[0] === "uploads") {
        domain = `${parts[0]}.${domain}`
    }
    // Basically if we don't try and be clever, we end up with uploads.blahblah.onion becoming -> chucksfarm.net
    return {redirectUrl: url.href.replace(url.host, domain)}
}

var enabled = true, instance = onionDomain,
    browser = browser || chrome;

browser.webRequest.onBeforeRequest.addListener(request => {
        const url = new URL(request.url);

        let config = {
            enabled: true,
            instance: onionDomain
        }

        // Hacky cancerous Chrome workarounds
        // Basically there's an issue where I can't block the request until I get the storage result
        // So the lousy workaround is to store the value as a global and refetch it each time
        // This causes a bug where the value doesn't take effect until the 2nd page load, but I can't find an acceptable
        // workaround as storage.onChanged isn't firing for unknown reasons and every answer on Google is useless
        if (isChrome) {
            browser.storage.sync.get({
                enabled: true,
                instance: onionDomain
            }, function (cfg) {
                enabled = cfg.enabled;
                instance = cfg.instance;
            });
            return createBlockingRequest(url, instance);
        }
        return browser.storage.sync.get(config).then((res) => {
            if (res.enabled) {
                return createBlockingRequest(url, res.instance);
            }
        }, (error) => {
            // Tor browser turns off the storage sync API by default
            // so just default to Tor mode for these guys
            console.log(`Failed to retrieve settings. Defaulting to onion redirect. Error was: ${error}`);
            return createBlockingRequest(url, onionDomain)
        });
    },
    {
        "urls": ["*://*.kiwifarms.net/*", "*://*.sneed.today/*", "*://*.kiwifarmsaaf4t2h7gc3dfc5ojhmqruw2nit3uejrpiagrxeuxiyxcyd.onion/*"],
        "types": [
            "main_frame",
            "sub_frame",
            "image",
            "media"
        ]
    },
    ["blocking"]
);